<template>
  <b-form-group
      :description="field.description"
      :label="field.label"
      :label-for="field.id">
    <b-form-select
        :id="field.id"
        :disabled="loading"
        :value="sort"
        @change="setSort"
        :options="field.options"/>
  </b-form-group>
</template>

<script>
import {mapState, mapActions, mapGetters} from 'vuex'
import {SORT_VIRAL, SORT_TOP, SORT_TIME, SORT_RISING} from '../service/imgur-service'

export default {
  name: 'SortFilter',
  computed: {
    ...mapState({
      sort: state => state.gallery.requestOptions.sort,
    }),
    ...mapGetters({
      loading: 'gallery/loading'
    })
  },
  data() {
    return {
      field: {
        id: 'sort-select',
        label: 'Sort by',
        description: 'Choose one of these sorting types',
        options: [
          {value: SORT_VIRAL, text: 'viral'},
          {value: SORT_TOP, text: 'top'},
          {value: SORT_TIME, text: 'time'},
          {value: SORT_RISING, text: 'rising'},
        ],
      }
    }
  },
  methods: {
    ...mapActions({
      setSort: 'gallery/setSort'
    })
  }
}
</script>

<style scoped>

</style>